import type { Settings as LayoutSettings } from '@ant-design/pro-layout';
import { PageLoading } from '@ant-design/pro-layout';
import type { RunTimeLayoutConfig } from 'umi';
import { history, Link } from 'umi';
import RightContent from '@/components/RightContent';
import Footer from '@/components/Footer';
import { currentUser as queryCurrentUser, queryPersonTxByYw } from './services/ant-design-pro/api';
import { BookOutlined, LinkOutlined } from '@ant-design/icons';
import { RequestConfig } from 'umi';
import { ResponseError } from 'umi-request';
import { notification } from 'antd';
import cookie from 'react-cookies';

const codeMessage = {
  200: '服务器成功返回请求的数据。',
  201: '新建或修改数据成功。',
  202: '一个请求已经进入后台排队（异步任务）。',
  204: '删除数据成功。',
  400: '发出的请求有错误，服务器没有进行新建或修改数据的操作。',
  401: '用户没有权限（令牌、用户名、密码错误）。',
  403: '用户得到授权，但是访问是被禁止的。',
  404: '发出的请求针对的是不存在的记录，服务器没有进行操作。',
  405: '请求方法不被允许。',
  406: '请求的格式不可得。',
  410: '请求的资源被永久删除，且不会再得到的。',
  422: '当创建一个对象时，发生一个验证错误。',
  500: '服务器发生错误，请检查服务器。',
  502: '网关错误。',
  503: '服务不可用，服务器暂时过载或维护。',
  504: '网关超时。',
};

const isDev = process.env.NODE_ENV === 'development';
const loginPath = '/user/login';

/** 获取用户信息比较慢的时候会展示一个 loading */
export const initialStateConfig = {
  loading: <PageLoading />,
};

/**
 * @see  https://umijs.org/zh-CN/plugins/plugin-initial-state
 * */
export async function getInitialState(): Promise<{
  settings?: Partial<LayoutSettings>;
  currentUser?: API.CurrentUser;
  fetchUserInfo?: () => Promise<API.CurrentUser | undefined>;
}> {
  const fetchUserInfo = async () => {
    try {
      const msg = await queryCurrentUser({
        person_id: cookie.load('person_id'),
        identity_id: cookie.load('identity_id'),
        u_type: 1, // 用户类型
        random_num: new Date().getTime(),
      });
      const tx = await queryPersonTxByYw({
        person_id: cookie.load('person_id'),
        identity_id: cookie.load('identity_id'),
        u_type: 1, // 用户类型
        random_num: new Date().getTime(),
      });
      // 角色权限判断 2: 校管理员 4: 普通教师
      /*
      const rule_ids = cookie.load('background_role_id')?.split(',') || []
      console.log('rules',rule_ids,rule_ids.indexOf(5))
      if(rule_ids.indexOf('2') === -1){
        cookie.remove('person_id')
        history.push(loginPath)
      }*/
      console.log('avatar: ',`/dsideal_yy/html/thumb/Material/${tx?.file_id?.substr(0,2)}/${tx?.file_id}.${tx?.extension}`)
      return {name: msg?.person_name, userid: msg?.person_id, avatar: `/dsideal_yy/html/thumb/Material/${tx?.file_id?.substr(0,2)}/${tx?.file_id}.${tx?.extension}`};
    } catch (error) {
      history.push(loginPath);
    }
    return undefined;
  };
  // 如果是登录页面，不执行
  if (history.location.pathname !== loginPath) {
    const currentUser = await fetchUserInfo();
    return {
      fetchUserInfo,
      currentUser,
      settings: {},
    };
  }
  return {
    fetchUserInfo,
    settings: {},
  };
}

// ProLayout 支持的api https://procomponents.ant.design/components/layout
export const layout: RunTimeLayoutConfig = ({ initialState }) => {
  return {
    rightContentRender: () => <RightContent />,
    disableContentMargin: false,
    /*
    waterMarkProps: {
      content: initialState?.currentUser?.name,
    },*/
    footerRender: () => <Footer />,
    onPageChange: () => {
      const { location } = history;
      // 如果没有登录，重定向到 login
      if (!initialState?.currentUser && location.pathname !== loginPath) {
        history.push(loginPath);
      }
    },
    menuHeaderRender: undefined,
    // 自定义 403 页面
    // unAccessible: <div>unAccessible</div>,
    ...initialState?.settings,
  };
};

/** 全局请求 */
/*
const requestInterceptor = (url: string, options: any) => {
  return {
    url: 'http://localhost:3009' + url, // 此处可以添加域名前缀
    options: {
      ...options,
      headers: {
        authorization: 'Bearer',
      },
    },
  };
};*/

/** 全局响应拦截 */
const responseInterceptor = async (response: any, options: any) => {
  const data = await response.clone().json();
  if (data && data?.status === '0') {
    //location.href = location.pathname + '#/user/login'; // /#/user/login
    history.push('/user/login')
  }
  // console.log('返回了', response);
  // console.log('options', options);
  return response;
};

/** request 用于配置全局的网络请求，你可以在这里做拦截器，全局错误处理，鉴权的配置。*/
export const request: RequestConfig = {
  errorHandler: (error: ResponseError) => {
    console.log('RequestConfig errorHandler', error)
    /*
    notification.error({
      description: '您的网络发生异常，无法连接服务器',
      message: '网络异常',
    });*/
    throw error;
  },
  //middlewares?: OnionMiddleware[],
  //requestInterceptors: [requestInterceptor], // 请求前拦截器
  responseInterceptors: [responseInterceptor], // 响应拦截器
};
